<?php
echo Date("Y-m-d H:i:s");
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
function cmp($a, $b){
    if ($a->importance == $b->importance) {
        return 0;
    }
    return ($a->importance < $b->importance) ? 1 : -1;
}
function cmp_cars($a, $b){
    if ($a["rating"] == $b["rating"]) {
        return 0;
    }
    return ($a["rating"] < $b["rating"]) ? 1 : -1;
}
function bin_rand($min = null, $max = null)
{
    $min = ($min) ? (int) $min : 0;
    $max = ($max) ? (int) $max : PHP_INT_MAX;
    
    $range = range($min, $max);
    $average = array_sum($range) / count($range);
    
    $dist = array();
    for ($x = $min; $x <= $max; $x++) {
        $dist[$x] = -abs($average - $x) + $average + 1;
    }
    
    $map = array();
    foreach ($dist as $int => $quantity) {
        for ($x = 0; $x < $quantity; $x++) {
            $map[] = $int;
        }
    }
    
    shuffle($map);
    return current($map);
}

class attribute_preference{
    public $attribute_name;
    public $importance;
    public $numeric_ideal_point;
    public $numeric_tolerance;
    public $nominal_ideal_value;
    
    function __construct($an, $i, $n1, $n2, $n4) {
        $this->attribute_name = $an;
        $this->importance = $i;
        $this->numeric_ideal_point = $n1;
        $this->numeric_tolerance = $n2;
        $this->nominal_ideal_value = $n4;
    }
}
class create_user_ratings {
    //put your code here
    const dbtable = "car_list2";
    const output_model = "user_model.txt";
    const output_ratings = "ratings_all.csv";
    const output_ratings_train = "ratings_train.csv";
    const output_ratings_test = "ratings_test.csv";
    const no_of_users = 100;
    const top_k = 200;
    
    private $attributes_preferences;  
    private $attribute_lists;
    private $attribute_types;
    private $user_preferences;

    //constructor method
    // - for specified number of users method first compute preference of the user and then let him rate some objects 
    function __construct(){  
        $f = fopen("generated_users100.txt", "w");
        $f2 = fopen("users_train100.csv", "w");
        $f3 = fopen("users_test100.csv", "w");
        require_once "lib/database.php";   
        database::connect();
        
        $this->attribute_lists = array("vyrobce","model","rok_vyroby", "najete_km", "objem", "vykon", "palivo", "spotreba", "cena" );
        $this->attribute_types = array("nominal","nominal","numeric","numeric","numeric","numeric","nominal","numeric","numeric" );
        $this->numeric_subtype = array("nominal","nominal","aditive","multiplikative","multiplikative","multiplikative","nominal","multiplikative","multiplikative"  );
        $this->numeric_avg_hit_zero = array("nominal","nominal",5,0.5,0.5,0.5,"nominal",0.2,0.3 );
        
        for($uid=1; $uid<=create_user_ratings::no_of_users; $uid++){
            $this->user_preferences[$uid] = $this->generate_random_preferences($uid);
            $this->generate_ratings($uid, $this->user_preferences[$uid], $f2, $f3);  
        }
        $users = print_r($this->user_preferences,true);
        fwrite($f, $users);
        
             
    }
    
    //for user with specified preferences, method pics random number of objects which user will rate
    //method picks both random cars from the dataset and also some of the best fitting cars according to user preferences
    //after ratings creation, method populates train set and test set CSV files
    function generate_ratings($uid, $up, $f2, $f3) {
        $limit = mt_rand(20, 100);
        $split = floor($limit * 4 / 5);
        $sql = "select * from " . create_user_ratings::dbtable . " where objem<20000 and objem>200 and spotreba<20 and cena >=100 and najete_km<10000000 order by Rand() limit $limit";
        $k = 0;
        $this->temp_preferences = $up;
        $query = mysql_query($sql);
        $train_array = array();
        $test_array = array();
        while ($row = mysql_fetch_array($query)) {
            $k++;
            $oid = $row["ID"];
            $rating = round($this->evaluate_car($row), 2);
            if ($k < $split) {
                $train_array[] = "$uid,$oid,$rating\n";
            } else {
                $test_array[] = "$uid,$oid,$rating\n";
            }
        }
        $top_cars_limit = mt_rand(5, sizeof( $this->candidate_set));
        $top_cars_split = floor($top_cars_limit * 4 / 5);
        
        $j=0;
        shuffle($this->candidate_set);
        foreach ($this->candidate_set as $key => $car) {
            $j++;
            if($j>$top_cars_limit){break;}
            $oid = $car["ID"];
            $rating = round($this->evaluate_car($car), 2);
            if ($j < $top_cars_split) {
                $train_array[] = "$uid,$oid,$rating\n";
            } else {
                $test_array[] = "$uid,$oid,$rating\n";
            }
        }
        shuffle($train_array);
        shuffle($test_array);
        fwrite($f2, implode("",$train_array));
        fwrite($f3, implode("",$test_array));
        
    }

    //generate local preferences for user $uid
    //method first get randomly which attributes are important for the user and the importance itself
    //then it calls compute_attribute_preference() for each relevant attribute
    function generate_random_preferences($uid){
        $preferences = array();
        foreach ($this->attribute_lists as $key => $value) {
            $have_pref = mt_rand(0, 5);
            if($have_pref==0){
                //no pref, do nothing
            }else{
                $importance = mt_rand(1,10);
                $preferences[] = new attribute_preference($value, $importance, "", "", "", "");
            }
            
        }
        $this->temp_preferences = array();
        usort($preferences, "cmp");
        foreach ($preferences as $key => $attribute) {
            $this->temp_preferences[] = $this->compute_attribute_preference($attribute);
        }
        return $this->temp_preferences;
    }
    
    //define local preference of the current user for specified attribute
    //the value is random, but it is dependant on the variants available in the dataset
    //ideal point and tolerance is defined for the numerical values,
    //set of values is defined for the nominal vals.
    function compute_attribute_preference($attribute){
        $this->candidate_set = $this->get_topk_cars();
        
        $attr_key = array_search($attribute->attribute_name, $this->attribute_lists);
        $attr_type = $this->attribute_types[$attr_key];
        if($attr_type == "nominal"){
            $nominal = "";
            $nominal_values = $this->get_list_nominal($attribute->attribute_name);
            
            //vyberu 1 nebo vice hodnot ze seznamu hodnot daneho atributu, oddelim je carkou
            $no_of_vals = mt_rand(1 , min(array(5, (sizeof($nominal_values)-1) )) );
            $indexes = array_rand($nominal_values, $no_of_vals);
            if($no_of_vals == 1){
               $nominal .= ", ".$nominal_values[$indexes]; 
            }else{
                foreach ($indexes as $index) {
                    $nominal .= ", ".$nominal_values[$index];  
                }
            } 
            $pref = new attribute_preference($attribute->attribute_name, $attribute->importance, "",  "", $nominal);
            return $pref;
        }else{
            //numeric
            $min_val = $this->get_min($attribute->attribute_name);
            $max_val = $this->get_max($attribute->attribute_name);
            $attr_param = $this->numeric_avg_hit_zero[$attr_key];
            $ideal_point = mt_rand(($min_val*100), ($max_val*100))/100;
            $distance = bin_rand(1, $attr_param*200)/100;
            $pref = new attribute_preference($attribute->attribute_name, $attribute->importance, $ideal_point, $distance, "");
            return $pref;            
        }                        
    }

    //get top-k best cars according to the user preferences
    function get_topk_cars(){
        $sql_all_cars = "select * from ".create_user_ratings::dbtable." where objem<20000 and objem>200 and spotreba<20 and cena >=100 and najete_km<10000000";
        $query = mysql_query($sql_all_cars);
        $all_cars = array();
        while ($row = mysql_fetch_array($query)) {
            $all_cars[$row["ID"]] = $row;
            $all_cars[$row["ID"]]["rating"] = $this->evaluate_car($row);            
        }
        usort($all_cars, "cmp_cars");
        $top_k = create_user_ratings::top_k / (sizeof($this->temp_preferences)+1);
        $rating = 1;
        $i=0;
        foreach ($all_cars as $key => $car) {
            $i++;
            if($i>$top_k and $rating!=$car["rating"]){
                break;
            }            
            if($car["rating"]!=$rating){
                $rating = $car["rating"];
            }
        }
        //$i obsahuje index kde mam pole roztrhnout
        return array_slice($all_cars, 0, $i, true);
                   
    }    
    
    //rate car according to the user preferences
    function evaluate_car($car){
        $sum_importance = 0;
        $sum_rating = 0;
        foreach ($this->temp_preferences as $attribute) {
            $attr_key = array_search($attribute->attribute_name, $this->attribute_lists);
            $attr_type = $this->attribute_types[$attr_key];
            $attr_subtype = $this->numeric_subtype[$attr_key];
            $sum_importance += $attribute->importance;
            
            if($attr_type == "nominal"){
                $sum_rating += $attribute->importance * $this->evaluate_nominal($attribute->nominal_ideal_value, $car[$attribute->attribute_name]);
            }else if($attr_subtype == "aditive"){
                $sum_rating += $attribute->importance * $this->evaluate_numeric_additive($attribute->numeric_ideal_point,$attribute->numeric_tolerance, $car[$attribute->attribute_name]);
            }else{
                $sum_rating += $attribute->importance * $this->evaluate_numeric_multiplikative($attribute->numeric_ideal_point,$attribute->numeric_tolerance, $car[$attribute->attribute_name]);               
            } 
        }
        if($sum_importance==0){
            return 1;
        }
        return $sum_rating/$sum_importance;
    }
    
    function evaluate_nominal($preference, $value){
        if(stripos($preference, $value) !== FALSE ){
            return 1;
        }
        return 0;
    }
    
    function evaluate_numeric_multiplikative($preference,$tolerance, $value){
        $tolerance_add = $preference * $tolerance;
        return $this->evaluate_numeric_additive($preference, $tolerance_add, $value);
    }  
    
    function evaluate_numeric_additive($preference,$tolerance, $value){
      //  echo $preference.", ".$tolerance.", ".$value."\n";
        $distance = abs($preference - $value);
        if($tolerance-$distance <= 0){
            return 0;
        }else{
            return ($tolerance-$distance)/$tolerance;
        }
        return 0;
    }
    
    function get_list_nominal($attr_name){
        $list = array();
        foreach ($this->candidate_set as $key => $car) {
            if(!in_array($car[$attr_name], $list)){
                $list[]=$car[$attr_name];
            }            
        }  
        return $list;
    }  
    
    function get_min($attr_name){
        $min = "NaN";
        foreach ($this->candidate_set as $key => $car) {
            if($min=="NaN" or $car[$attr_name] < $min){
                $min = $car[$attr_name];
            }           
        }  
        return $min;        
                   
    }     
    
    function get_max($attr_name){
        $max = "NaN";
        foreach ($this->candidate_set as $key => $car) {
            if($max=="NaN" or $car[$attr_name] > $max){
                $max = $car[$attr_name];
            }           
        }  
        return $max;                      
    } 
      
}
//generate specified number of users with their preferences and according to them also with user ratings
new create_user_ratings();

echo "\n end:".Date("Y-m-d H:i:s");